// StringEncoder.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <tchar.h>
#include <iostream>
#include <fstream>

using namespace std;


char toUpper(char s)
{

	if(s >= 97 && s <= 122)
	{
		s -= 32;
	}

	return s;

}


int _tmain(int argc, _TCHAR* argv[])
{
	ifstream charRef;
	ofstream outFile;
	char outString[256];
	char inLine[256];
	char curChar, testChar = '%';
	char* pch;
	int count, hex_count = 0;
	int encode[16];

	for(int i = 0; i < 16; i++)
	{
		encode[i] = 0;
	}


	cout << "Enter a message to be displayed. (28 character max)\n";

	cin.getline(outString, 256);

	count = cin.gcount();

	for(int i = 0; i < 256; i++)
	{
		outString[i] = toUpper(outString[i]);
	}

	charRef.open("charlist8.txt");				// This file contains the list of encoded characters

	if(!charRef.is_open())
	{
		cout << "Unable to open character list!\n";
		return 0;
	}

	outFile.open("stringcode.txt");
	if(!outFile.is_open())
	{
		cout << "Unable to open output file!\n";
		return 0;
	}

	for(int i = 0; i < count - 1; i++)
	{

		testChar = '&';
		
		charRef.seekg (0, ios::beg);		// Reset the position of the file pointer
		
		curChar = outString[i];

		while(testChar != curChar)			// Find the character int he list
		{
			charRef.getline(inLine, 256);
			testChar = inLine[0];
		}

		pch = strtok(inLine, ",");			// Split the string into tokens 

		for(int i = 0; i < 10; i++)
		{
			pch = strtok(NULL, ",");
			encode[i] = atoi(pch);
		}


		for(int i = 0; i < 10; i++)					// Write to the output file in assembly
		{
			outFile << "	DATA	0x" << hex << encode[i] << endl;
			hex_count++;
		}

	}

		outFile << "	movlw	0x" << hex << --hex_count << endl;
		outFile << "	movwf	MSG_COUNT\n";
		outFile << "\n";


	charRef.close();
	outFile.close();

	

	

	return 0;
}

